//随访项目数据
//--------------------随访模板------------------------
//-----type 1-文本输入，2-radio选择，3-checkbox, 4-textarea
//-----textType :string, number ,date (type == 1时，才区分)
var gTemplate = {
// - 症状
    "1":{
        "NO_SYMPTOM":{
            "label": "无症状",
            "type": 3,
            "width": ""
        },
        "HEADACHE":{
            "label": "头痛头晕",
            "type": 3
        },
        "NAUSEA":{
            "label": "恶心呕吐",
            "type": 3
        },
        "VERTIGO_TINNITUS":{
            "label": "眼花耳鸣",
            "type": 3
        },
        "DIFFICULTY_BREATHING":{
            "label": "呼吸困难",
            "type": 3
        },
        "PALPITATIONS":{
            "label": "心悸胸闷",
            "type": 3
        },
        "EPISTAXIS_BLEEDING":{
            "label": "鼻衄出血不止",
            "type": 3
        },
        "LIMBS_NUMB":{
            "label": "四肢发麻",
            "type": 3
        },
        "EXTREMITY_EDEMA":{
            "label": "下肢水肿",
            "type": 3
        },
        "POLYDIPSIA":{
            "label": "多饮",
            "type": 3
        },
        "MORE_FOOD":{
            "label": "多食",
            "type": 3
        },
        "MORE_URINE":{
            "label": "多尿",
            "type": 3
        },
        "BLURRED_VISION":{
            "label": "视力模糊",
            "type": 3
        },
        "INFECTION":{
            "label": "感染",
            "type": 3
        },
        "NUMB_HANDS":{
            "label": "四肢麻痹",
            "type": 3
        },
        "WEIGHT_LOSS":{
            "label": "体重下降",
            "type": 3
        },
        "HYPOG_REACT_CODE":{
            "label": "低血糖反应",
            "type": 2,
            "items": {
                "0": "无",
                "1": "偶尔",
                "2": "频繁"
            }
        },
        "SYMPTOM_OTHER":{
            "label": "其他",
            "type":4,
            "row": 1,
            "maxLength": 100,
            "width": "100%"
        }
    },
    //-体征
    "2":{
        "BP": {
            "label": "血压",
            "type": 5, //联动输入框
            "unit": "mmHg",
            "required": true,
            "separate": " / ",
            "items": [{
                "textType": "number",
                "type": 1,
                "name": "BP_D", //收缩压
                "step": 1,
                "width": "60px"
            },{
                "textType": "number",
                "type": 1,
                "name": "BP_U", //舒张压
                "step": 1,
                "width": "60px"
            }]
        },
        "HEIGHT":{
            "label":"身高",
            "type":1,
            "unit":"cm",
            "textType": "number",
            "step": 0.1,
            "width": "100px"
        },
        "WEIGHT":{
            "label":"体重",
            "type":1,
            "unit":"Kg",
            "textType": "number",
            "step": 0.1,
            "width": "100px"
        },
        "BMI":{
            "label":"体质指数",
            "type":1,
            "textType": "string",
            "readonly": "readonly",
            "width": "100px"
        },
        "WEIGHT_EXP":{
            "label":"期望体重",
            "type":1,
            "unit":"Kg",
            "textType": "number",
            "step": 0.1,
            "width": "100px"
        },
        "BMI_EXP":{
            "label":"期望体质指数",
            "type":1,
            "textType": "string",
            "readonly": "readonly",
            "width": "100px"
        },
        "HEART_RATE":{
            "label":"心率",
            "type":1,
            "unit":"次/分",
            "textType": "number",
            "step": 1,
            "width": "100px"
        },
        "POFDA_MARK":{
            "label":"足背动脉搏动",
            "type":1,
            "textType": "select",
            "options": [{
                "key": "1",
                "value": "未触及"
            },{
                "key": "2",
                "value": "触及"
            }],
            "width": "100px"
        },
        "OTHER_POSITIVE_SIGNS":{
            "label":"其他",
            "type":1,
            "textType": "string",
            "width": "180px"
        }
    },
    //-实验室检查
    "3":{
    	"EXAM_DATE":{
            "label":"检查日期",
            "type":1,
            "textType": "date"
        },
        "BS_FPG":{
            "label":"空腹血糖",
            "type":1,
            "unit":"mmol/L",
            "textType": "number",
            "step": 0.01,
            "width": "80px"
        },
        "NO_BS_FPG":{
            "label":"餐后血糖",
            "type":1,
            "unit":"mmol/L",
            "textType": "number",
            "step": 0.01,
            "width": "80px"
        },
        "RANDOM_BLOOD_SUGAR": {
        	"label":"随机血糖",
            "type":1,
            "unit":"mmol/L",
            "textType": "number",
            "step": 0.01,
            "width": "80px"
        },
        "GHB":{
            "label":"糖化血红蛋白",
            "type":1,
            "unit":"%",
            "textType": "number",
            "step": 0.1,
            "width": "80px"
        },
        "BLOOD_FAT_TRIGLYCERIDE":{
            "label":"甘油三酯",
            "type":1,
            "unit":"mmol/L",
            "textType": "number",
            "step": 0.01,
            "width": "80px"
        },
        "BLOOD_FAT_TC":{
            "label":"总胆固醇",
            "type":1,
            "unit":"mmol/L",
            "textType": "number",
            "step": 0.01,
            "width": "80px"
        },
        "BLOOD_FAT_LDLC":{
            "label":"低密度脂蛋白",
            "type":1,
            "unit":"mmol/L",
            "textType": "number",
            "step": 0.01,
            "width": "80px"
        },
        "RENAL_FUNCTION_CREATININE":{
        	"label":"血清肌酐",
            "type":1,
            "unit":"umol/L",
            "textType": "number",
            "step": 0.1,
            "width": "80px"
        },
        "RENAL_FUNCTION_BUN":{
        	"label":"血尿素氮",
            "type":1,
            "unit":"mmol/L",
            "textType": "number",
            "step": 0.1,
            "width": "80px"
        },
        "MICROALBUMINURIA":{
        	"label":"尿微量白蛋白",
            "type":1,
            "unit":"μg/min",
            "textType": "number",
            "step": 0.01,
            "width": "80px"
        }
    },
    //-生活方式指导
    "4":{
        "DAILY_SMOKING":{
            "label":"日吸烟量",
            "type":1,
            "unit":"支",
            "textType": "number",
            "step": 1,
            "width": "60px"
        },
        "SOMKING_EXP":{
            "label":"日吸烟量期望",
            "type":1,
            "unit":"支",
            "textType": "number",
            "step": 1,
            "width": "60px"
        },
        "DAILY_DRINKING":{
            "label":"日饮酒量",
            "type":1,
            "unit":"两",
            "textType": "number",
            "step": 1,
            "width": "60px"
        },
        "DRINK_EXP":{
            "label":"日饮酒量期望",
            "type":1,
            "unit":"两",
            "textType": "number",
            "step": 1,
            "width": "60px"
        },
        "EXERCISE_FREQ_CODE":{
            "label":"运动频率",
            "type":5,
            "required": true,
            "unit": "分钟/次",
            "separate": "",
            "items": [{
                "name": "EXERCISE_FREQ_CODE",
                "type": 1,
                "textType": "select",
                "width": "200px",
                "options":[{
                    "key": "1",
                    "value": "每周 <= 三次"
                },{
                    "key": "2",
                    "value": "每周 > 三次"
                },{
                    "key": "3",
                    "value": "极少运动"
                },{
                    "key": "4",
                    "value": "残疾、关节等原因不能运动"
                },{
                    "key": "99",
                    "value": "不详"
                }]
            },{
                "name": "EXERCISE_DURATION_MINS",
                "type": 1,
                "textType": "number",
                "step": 1,
                "width": "60px"
            }]
        },
        "EXERCISE_FREQ_CODE_EXP":{
            "label":"运动频率期望",
            "type":5,
            "required": true,
            "unit": "分钟/次",
            "separate": "",
            "items": [{
                "name": "EXERCISE_FREQ_CODE_EXP",
                "type": 1,
                "textType": "select",
                "width": "200px",
                "options":[{
                    "key": "1",
                    "value": "每周 <= 三次"
                },{
                    "key": "2",
                    "value": "每周 > 三次"
                },{
                    "key": "3",
                    "value": "极少运动"
                },{
                    "key": "4",
                    "value": "残疾、关节等原因不能运动"
                },{
                    "key": "99",
                    "value": "不详"
                }]
            },{
                "name": "EXERCISE_DURATION_MINS_EXP",
                "type": 1,
                "textType": "number",
                "step": 1,
                "width": "60px"
            }]
        },
        "SALT_TAKEN_LEVEL_CODE":{
            "label":"摄盐情况",
            "type":1,
            "required": true,
            "textType": "select",
            "width": "120px",
            "options":[{
                "key": "1",
                "value": "轻"
            },{
                "key": "2",
                "value": "中"
            },{
                "key": "3",
                "value": "重"
            }]
        },
        "SALT_TAKEN_LEVEL_EXP":{
            "label":"摄盐情况期望",
            "type":1,
            "textType": "select",
            "width": "120px",
            "options":[{
                "key": "1",
                "value": "轻"
            },{
                "key": "2",
                "value": "中"
            },{
                "key": "3",
                "value": "重"
            }]
        },
        "PSY_ADJUST_RESULT_CODE":{
            "label":"心理调整",
            "type":1,
            "textType": "select",
            "width": "120px",
            "options":[{
                "key": "1",
                "value": "理想"
            },{
                "key": "2",
                "value": "良好"
            },{
                "key": "3",
                "value": "一般"
            },{
                "key": "4",
                "value": "差"
            }]
        },
        "COMPLIANCE_RESULT_CODE":{
            "label":"遵医行为",
            "type":1,
            "textType": "select",
            "width": "120px",
            "options":[{
                "key": "1",
                "value": "理想"
            },{
                "key": "2",
                "value": "良好"
            },{
                "key": "3",
                "value": "一般"
            },{
                "key": "4",
                "value": "差"
            }]
        },
        "DAILY_STAPLE":{
            "label":"主食",
            "type":1,
            "unit":"克/天",
            "textType":"number",
            "step": 1,
            "width": "60px"
        }
    },
    // - 评价
    "5":{
        "HYP_FOLLOWUP_TYPE_CODE":{
            "label":"高血压随访分类",
            "required":true,
            "type":1,
            "textType": 'select',
            "width": "120px",
            "options":[{
                "key": "1",
                "value": "控制满意"
            },{
                "key": "2",
                "value": "控制不满意"
            },{
                "key": "3",
                "value": "不良反应"
            },{
                "key": "4",
                "value": "并发症"
            },{
                "key": "5",
                "value": "控制一般"
            }]
        },
        "HYP_COMPLICATION_DETAIL":{
            "label":"详情",
            "type":4,
            "row": 3,
            "maxLength": 100,
            "width": "100%",
        },
        "DIA_FOLLOWUP_TYPE_CODE":{
            "label":"糖尿病随访分类",
            "required":true,
            "type":1,
            "textType": 'select',
            "width": "120px",
            "options":[{
                "key": "1",
                "value": "控制满意"
            },{
                "key": "2",
                "value": "控制不满意"
            },{
                "key": "3",
                "value": "不良反应"
            },{
                "key": "4",
                "value": "并发症"
            },{
                "key": "5",
                "value": "控制一般"
            }]
        },
        "DIA_COMPLICATION_DETAIL":{
            "label":"详情",
            "type":4,
            "row": 3,
            "maxLength": 100,
            "width": "100%",
        }
    },
    // - 用药情况
    "6":{
        "DRUG_COMPLIANCE_CODE":{
            "label": "服药依从性",
            "type": 2,
            "items":{
                "1":"规律服药",
                "2": "间断服药",
                "3": "不服药"
            }
        },
        "DRUG_LIST":{
            "label":"用药记录",
            "type":"json"
        }
    },
    // - 控制目标
    "7":{
        "CONTROL_DATE":{
            "label":"控制日期",
            "type":1,
            "textType": "date"
        },
        "CONTROL_CONSTITUTOR":{
            "label":"制定者",
            "type":1,
            "textType": "string",
            "readonly":"readonly",
            "width": "120px"
        },
        "CONTROL_BP":{
            "label": "血压",
            "type": 5,
            "unit": "mmHg",
            "separate": " / ",
            "items":[{
                "name": "CONTROL_BP_U",
                "type": 1,
                "textType": "number",
                "step": 1,
                "width": "60px"
            },{
                "name": "CONTROL_BP_D",
                "type": 1,
                "textType": "number",
                "step": 1,
                "width": "60px"
            }]
        },
        
        "CONTROL_BS_FPG":{
            "label":"空腹血糖",
            "type":1,
            "unit": "mmol/L",
            "textType": "number",
            "step": 0.01,
            "width": "60px"
        },
        "CONTROL_NO_BS_FPG":{
            "label":"餐后血糖",
            "type":1,
            "unit": "mmol/L",
            "textType": "number",
            "step": 0.01,
            "width": "60px"
        },
        "CONTROL_GHB":{
            "label":"糖化血红蛋白",
            "type":1,
            "unit": "%",
            "textType": "number",
            "step": 0.1,
            "width": "60px"
        },
        "CONTROL_TRIGLYCERIDE":{
            "label":"甘油三酯",
            "type":1,
            "unit": "mmol/L",
            "textType": "number",
            "step": 0.01,
            "width": "60px"
        },
        "CONTROL_TOTAL_CHOLESTEROL":{
            "label":"总胆固醇",
            "type":1,
            "unit": "mmol/L",
            "textType": "number",
            "step": 0.01,
            "width": "60px"
        },
        "CONTROL_LDL":{
            "label":"低密度脂蛋白",
            "type":1,
            "unit": "mmol/L",
            "textType": "number",
            "step": 0.1,
            "width": "60px"
        },
        "CONTROL_WEIGHT":{
            "label":"体重",
            "type":1,
            "unit": "Kg",
            "textType": "number",
            "step": 0.1,
            "width": "60px"
        },
        "CONTROL_EXERCISE_FREQ_CODE":{
            "label":"运动频率",
            "type":5,
            "unit": "分钟/次",
            "items":[{
                "name": "CONTROL_EXERCISE_FREQ_CODE",
                "type": 1,
                "textType": "select",
                "width": "200px",
                "options":[{
                    "key": "1",
                    "value": "每周 <= 三次"
                },{
                    "key": "2",
                    "value": "每周 > 三次"
                },{
                    "key": "3",
                    "value": "极少运动"
                },{
                    "key": "4",
                    "value": "残疾、关节等原因不能运动"
                },{
                    "key": "99",
                    "value": "不详"
                }]
            },{
                "name": "CONTROL_EXERCISE_DURATION_MINS",
                "type": 1,
                "textType": "number",
                "step": 1,
                "width": "60px"
            }]
            
        },
    },
    //- 健康教育
    "8":{
        "ARCHIVE_TIME":{
            "label":"日期",
            "type":1,
            "textType": "date"
        },
        "ARCHIVE_OPERATOR_NAME":{
            "label":"记录者",
            "type":1,
            "textType": "string",
            "width": "100px"
        },
        "HEALTH_EDUCATE":{
            "label":"健康教育",
            "required":true,
            "type":1,
            "textType": "select",
            "width": "200px",
            "options":[{
                "key": 1,
                "value": "高血压健康教育"
            },{
                "key": 2,
                "value": "糖尿病健康教育"
            },{
                "key": 3,
                "value": "低盐饮食"
            },{
                "key": 4,
                "value": "自定义高血压健康教育"
            },{
                "key": 5,
                "value": "自定义糖尿病健康教育"
            },{
                "key": 6,
                "value": "高糖并存健康教育处方"
            }]
        },
        "EDUCATE_CONTENT":{
            "label":"教育内容",
            "type":4,
            "row": 8,
            "maxLength": 2000,
            "width": "100%",
        }
    },
    //- 转诊
    "9":{
        "DRUG_ADVERSE":{
            "label":"药物不良反应",
            "type": 5,
            "items": [{
                "name": "DRUG_ADVERSE_MARK",
                "type": 2,
                "textType": "radio",
                "options":{
                    "0": "无",
                    "1": "有"
                }
            },{
                "name": "ADR_REMARK",
                "type": 1,
                "textType": "text",
                "width": "200px",
                "maxLength": 200
            }]
        },
        "DISAGREE_TRANSFER":{
            "label":"患者拒绝转诊",
            "type":5,
            "items":[{
                "name": "DISAGREE_TRANSFER",
                "type": 2,
                "textType": "radio",
                "options":{
                    "0": "否",
                    "1": "是"
                }
            },{
                "name": "DISAGREE_TRANSFER_REASON",
                "type": 1,
                "textType": "text",
                "width": "200px",
                "maxLength": 200
            }]
        },
        "TRANSFER_RESON":{
            "label":"转诊原因",
            "type":4,
            "required": true,
            "row": 3,
            "maxLength": 200,
            "width": "100%"
        },
        "TRANSFER_ORG_DEPT":{
            "label":"转诊机构科室",
            "type":4,
            "required": true,
            "row": 3,
            "maxLength": 200,
            "width": "100%"
        }
    }
}
